#ifndef Y_BLITBUF_HPP
    #define Y_BLITBUF_HPP

#include "ytypes.hpp"

// Basic BlitBuf functions
void clear_blitbuf(blitbuf *buf);
void fill_blitbuf(BYTE color, blitbuf *buf);
void alloc_blitbuf(blitbuf *buf, DIST xsize, DIST ysize);

// Adjust color in blitbuf
void greyscale_blitbuf(blitbuf *buf);
void RGB_blitbuf(blitbuf *buf);

// Image processing: These expect a linear blitbuf
void scale_blitbuf(DIST dest_x, DIST dest_y,
    blitbuf *buf1, blitbuf *buf2 = NULL);
void vertical_scale_blitbuf(DIST dest_y, blitbuf *buf1, blitbuf *buf2 = NULL);
void flip_vertical_blitbuf(blitbuf *buf);
void flip_horizontal_blitbuf(blitbuf *buf);
void scale_scanline(BYTE *source, BYTE *dest, DIST smap_size,
    DIST dmap_size, DIST dline_size);

void bitblit(COORD x, COORD y, blitbuf *buf);
void getblit(COORD x, COORD y, blitbuf *buf);

// Transparent blits must be aligned and 0 is the "transparent" value
void transparent_bitblitX(COORD x, COORD y, blitbuf *buf);

// PCX functions
void save_blitbufPCX(char *fname, blitbuf *buf);
int  load_blitbufPCX(char *fname, blitbuf *buf);

#endif

