#include <conio.h>
#include <dos.h>
#include <mem.h>

#include "ypal.hpp"

BYTE vga_pal[768];


void
set_palette(BYTE *pal, FLAG downgrade)
{
    short int i;
    BYTE *buf;

    memcpy(vga_pal, pal, 768);

    if (downgrade) {
        buf = vga_pal;
        i=768;
        while (i--) {
            *buf++ = (*buf >> 2);
        }
    }

    outp(0x03c8, 0);  // Start with color 0
    buf = vga_pal;
    i=256;
    while (i--) {
        outp(0x03c9, *buf++);
        outp(0x03c9, *buf++);
        outp(0x03c9, *buf++);
    }
}


void
get_palette(BYTE *pal, FLAG upgrade)
{
    int i;

    memcpy(pal, vga_pal, 768);

    if (upgrade) {
        i=768;
        while (i--) {
            *pal++ = (*pal << 2);
        }
    }
}


void
get_BIOSpalette(BYTE *pal, FLAG upgrade)
{
    int i;
    union REGS r;

    r.x.eax = 0x1017;
    r.x.ebx = 0;
    r.x.ecx = 256;
    r.x.edx = (unsigned long) pal;

    int386(0x10, &r, &r);

    if (upgrade) {
        i=768;
        while (i--) {
            *pal++ = (*pal << 2);
        }
    }
}


void
grey_palette(void)
{
    smooth64_palette(1, 1, 1);
}


void
RGB_palette(void)
{
    BYTE r, g, b;
    BYTE temp_pal[768];
    BYTE *temp;

    temp = temp_pal;

    for (r=0; r < 8; r++) {
        for (g=0; g < 8; g++) {
            for (b=0; b < 4; b++) {
                *temp++ = (r << 3);
                *temp++ = (g << 3);
                *temp++ = (b << 4);
            }
        }
    }

    set_palette(temp_pal, 0);
}


void
smooth64_palette(BYTE r, BYTE g, BYTE b)
{
    short int i;
    BYTE temp_pal[768];
    BYTE *temp;

    memset(temp_pal, 0, 768);


    if (r) {
        temp = temp_pal;
        for (i=0; i < 64; i++) {
            *temp = i;
            temp += 3;
        }
    }

    if (g) {
        temp = temp_pal + 1;
        for (i=0; i < 64; i++) {
            *temp = i;
            temp += 3;
        }
    }

    if (b) {
        temp = temp_pal + 2;
        for (i=0; i < 64; i++) {
            *temp = i;
            temp += 3;
        }
    }

    set_palette(temp_pal, 0);
}

